Subject: bug#745: pop-to-buffer, frames, and input focus

From: Helmut Eller <[email-masked]>
Date: Thu, 21 Aug 2008 15:20:18 +0200

* martin rudalics [2008-08-21 11:04+0200] writes:

>> Consider my original example:
>>
>> (progn
>>   (let ((frame (selected-frame))
>>         (pop-up-frames t))
>>     (display-buffer (get-buffer-create "foo"))
>>     (select-frame-set-input-focus frame))
>>
>>   (let ((display-buffer-reuse-frames t))
>>     (pop-to-buffer "foo")))
>>
>> First, display-buffer is just used to create two frames.  This switches
>> (surprisingly) focus to the "foo" buffer.  select-frame-set-input-focus
>> is used to force the focus back to the "*scratch*" buffer.  Then we use
>> pop-to-buffer, but the input focus remains (surprisingly) in the
>> "*scratch*" buffer.
>
> Ahhh, I can't reproduce that.  Evaluating your `progn' moves focus to
> the `foo' buffer here (with emacs -Q).  So it seems we have a platform
> (maybe window manager) specific problem.

I have tried a few window managers now.  

pop-to-buffer doesn't switch input focus with: Sawfish, kwin,
metacity, fluxbox, twm.  
It does with icewm.

display-buffer seems to switch focus with: Sawfish, kwin, fluxbox,
icewm, twm.

Metacity seems to make the decision based on the mouse pointer, but it's
not clear how.  The new buffer receives the input focus sometimes but
not always.

>
>> I expect this:
>>
>>   pop-to-buffer     should switch the input focus
>>   display-buffer    should not change the input focus
>
> `pop-to-buffer' has the sole additional twist WRT `display-buffer':
>
>     (select-window (display-buffer buffer other-window) norecord)
>
> That is, the window used by `display-buffer' should get definitively
> selected.  So, if `display-buffer' has decided to use "another" frame,
> raising that frame, giving it input focus, and implicitly selecting that
> frame and the window used for displaying the buffer_must_ have been
> already handled by `display-buffer'.  In this case, the `select-window'
> done by `pop-to-buffer' looks like a NOOP though I didn't verify that.

I still think that display-buffer should neither select the other frame
nor give it the input focus.  (Whether the other frame should be raised
or not should probably be customizable, but that's a minor issue.)

If the problem only occurs for new frames it's not so serious, tough.
Once created, frames will probably stay there for a while and not be
continuously closed/created.  It's probably also harder to stop window
managers from doing stupid things with new frames.

>>> All I wanted to say that raising a
>>> frame, giving it input focus, and _not_ selecting it might be difficult.
>>
>> I see.  But this is also not what I expect.
>
> So `pop-to-buffer' raising a frame + giving it input focus + selecting
> it is always OK with you?

Yes, I think so.

>
>> pop-to-buffer is more or less (select-window (display-buffer ...)).
>> This looks very reasonable, but it doesn't transfer the input focus.
>> (under X; in a tty everything works well.)
>>
>> On the other hand, display-buffer switches sometimes (when a new frame
>> is created) the input focus, even when that was not asked for.
>>
>> Maybe pop-to-buffer could do something like
>>
>>   (let ((window (display-buffer ...)))
>>     (select-window window)
>>     (select-frame-set-input-focus (window-frame window)))
>>
>> That would solve my immediate problem, ...
>
> Does it solve all your problems in this context?  

For now, yes :-)    

> I suppose it won't be
> of any help when you use `display-buffer' with `pop-up-frames' t :-(

Well, yeah this wouldn't fix display-buffer.  

>> ... but I suspect that select-window
>> should be smarter.  My naive interpretation of select-window's C source
>> is that select-window tries to select the frame.  But apparently forgets
>> about the input focus.  This may also be the reason why
>> save-window-excursion doesn't restore the input focus.
>>
>> Selecting a window, without giving it the input focus is probably rarely
>> needed.  Perhaps select-window should transfer the input focus by
>> default.
>
> I suppose we can't do that.  `select-window' is frequently used to
> temporarily switch to another window (compare `save-selected-window').

Hmm, I see.  Yet, select-window calls Fselect_frame.
The distinction between select-frame and select-frame-set-input-focus
is certainly confusing.

> Shifting input focus to another frame and possibly back to the initial
> frame might confuse the window manager.

That would be a stupid window manager :-) 

Helmut.